/*
 * Secure eXtended Message Passing framework
 * Secure eXtended Transport layer implementation: (libsxt)
 * - very similar to SSH2/TLS
 * - using already proven and tested crypto algos
 * - better than TLS for message passing
 *
 * (c) Alexander Vdolainen 2016 <avdolainen@zoho.com>
 *
 * libsxmp is free software: you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published
 * by the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libsxmp is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.";
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <errno.h>
#include <string.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/types.h>

uint64_t ntohll(uint64_t n)
{
#ifdef WORDS_BIGENDIAN
  return n;
#else /* WORDS_BIGENDIAN */
  return (((uint64_t)(n) << 56) | \
         (((uint64_t)(n) << 40) & 0xff000000000000ULL) | \
         (((uint64_t)(n) << 24) & 0xff0000000000ULL) | \
         (((uint64_t)(n) << 8)  & 0xff00000000ULL) | \
         (((uint64_t)(n) >> 8)  & 0xff000000ULL) | \
         (((uint64_t)(n) >> 24) & 0xff0000ULL) | \
         (((uint64_t)(n) >> 40) & 0xff00ULL) | \
         ((uint64_t)(n)  >> 56));
#endif /* WORDS_BIGENDIAN */
}

